#! /bin/sh
# RWikiȰ¸饤֥Υ󥹥ȡ
# copyright (c) 2000 ZnZ <zn@mbf.nifty.com>

# ѥǥ쥯ȥ
WORK=/tmp
WGET='wget -N'
# 饤֥򥤥󥹥ȡ뤹
PREFIX=${HOME}
LIB=${PREFIX}/lib/ruby
BIN=${PREFIX}/bin
# RWikiϤβ˥󥹥ȡ뤵
RWIKIPARENTDIR=${PREFIX}
# CGI򥤥󥹥ȡ뤹
CGIDIR=${PREFIX}/public_html
CGINAME=rw.cgi

set -e

PATH=${BIN}:$PATH
RUBYLIB_ORG=$RUBYLIB
RUBYLIB=${LIB}:$RUBYLIB
export RUBYLIB

if [ -z "$EDITOR" ]; then
  EDITOR=vi
fi

if ruby -e 'exit RUBY_VERSION < "1.6" ? 0 : 1'; then
  echo 'RWikiϥ饹ѿ(@@)ȤäƤ뤿ruby/1.6ϤɬפǤ'
  exit 0
fi

for DIR in ${WORK}/rwiki-installer $LIB $BIN $RWIKIDIR $CGIDIR; do
  if [ ! -d $DIR ]; then
    mkdir -p $DIR || exit 1
  fi
done

# enter working directory
WORK=${WORK}/rwiki-installer
cd $WORK || exit 2


# define functions begin

# RAAɤŸ롣
raaget () {
  NAME=$1
  URL=$2

  if [ ! -f raa-${NAME}.html ]; then
    $WGET -O raa-${NAME}.html $URL || exit 3
  fi
  URL=`grep tar.gz raa-${NAME}.html|sed 's/<[^>][^>]*>//g'`
  FILENAME=`basename ${URL}`
  if [ ! -f $FILENAME ]; then
    $WGET $URL || exit 4
  fi

  zcat $FILENAME | tar -xf -
}

# ʸ󤫤Ϥޤǥ쥯ȥ˰ư롣
changedir () {
  for DIR in ${1}*; do
    if [ -d $DIR ]; then
      cd $DIR || exit 5
      return
    fi
  done
}

cpfile () {
  changedir $1
  cp -fp $2 $LIB || exit 7
  cd ..
}

# setup.rbȤä󥹥ȡ
rsetup () {
  changedir $1
  ruby setup.rb config --bin-dir=$BIN --rb-dir=$LIB --so-dir=$LIB || exit 8
  ruby setup.rb setup   || exit 9
  ruby setup.rb install || exit 10
  ruby setup.rb clean   || exit 11
  rm -rf config.save ext/cparse/Makefile ext/strscanso/Makefile
  cd ..
}

# 饤֥꤬󥹥ȡ뤵Ƥ뤫ɤΥå
libcheck () {
  ruby -e "begin;require '$1';rescue LoadError;exit 1;end"
}

# define functions end


# library install begin

if which racc>/dev/null 2>&1; then
  echo raccϥ󥹥ȡ뤵Ƥޤ
else
  echo raccΥ󥹥ȡ򳫻Ϥޤ
  raaget racc 'http://www.ruby-lang.org/en/raa-list.rhtml?name=Racc'
  rsetup racc
  echo raccΥ󥹥ȡ뤬λޤ
fi

if libcheck 'strscan'; then
  echo strscanϥ󥹥ȡ뤵Ƥޤ
else
  echo strscanΥ󥹥ȡ򳫻Ϥޤ
  raaget strscan 'http://www.ruby-lang.org/en/raa-list.rhtml?name=strscan'
  rsetup strscan
  echo strscanΥ󥹥ȡ뤬λޤ
fi

if libcheck 'optparse'; then
  echo OptionParserϥ󥹥ȡ뤵Ƥޤ
else
  echo OptionParserΥ󥹥ȡ򳫻Ϥޤ
  raaget optparse 'http://www.ruby-lang.org/en/raa-list.rhtml?name=OptionParser'
  cpfile optparse optparse.rb
  echo OptionParserΥ󥹥ȡ뤬λޤ
fi

if libcheck 'rd/rdfmt'; then
  echo RDtoolϥ󥹥ȡ뤵Ƥޤ
else
  echo RDtoolΥ󥹥ȡ򳫻Ϥޤ
  raaget rdtool 'http://www.ruby-lang.org/en/raa-list.rhtml?name=RDtool'

  changedir rdtool
  ruby rdtoolconf.rb || exit 12
  cp Makefile Makefile.orig || exit 13
  awk "/^BIN_DIR/{print \"BIN_DIR = $BIN\";next} /^SITE_RUBY/{print \"SITE_RUBY = $LIB\";next} /^RD_DIR/{print \"RD_DIR = ${LIB}/rd\";next} {print}" Makefile.orig > Makefile || exit 14
  rm Makefile.orig || exit 15
  # cp missing/rd/* rd
  make install install-rmi2html || exit 16
  make clean || exit 17
  cd ..
  echo RDtoolΥ󥹥ȡ뤬λޤ
fi

# library install end


# RWiki install begin

echo RWikiΥ󥹥ȡ򳫻Ϥޤ
cd $RWIKIPARENTDIR || exit 18
raaget rwiki 'http://www.ruby-lang.org/en/raa-list.rhtml?name=RWiki'
changedir rwiki
RWIKI_DIR=`pwd`
echo -n rw-config.rb򤷤Ƥ [Press Enter]
cp rw-config.rb rw-config.rb.orig
awk "/^  MAILTO/{sub(/'[^']+'/,\"'mailto:`whoami`@`hostname`'\")}/^  ADDRESS/{sub(/'[^']+'/,\"'`whoami`'\")}/^  CGI_NAME/{sub(/'[^']+'/,\"'$CGINAME'\")}{print}" rw-config.rb.orig > rw-config.rb
read
$EDITOR rw-config.rb || exit 19

# set DRB_URI
eval `grep druby rw-config.rb|sed 's/ //g;s|druby://:|druby://localhost:|'`

# install rw-cgi.rb to ${CGIDIR}/${CGINAME}
awk "NR==1{print \"#!`which ruby`\";next} /^.RWIKI_DIR/{sub(/File[^)]+\\)/,\"'$RWIKI_DIR'\")} /^.RWIKI_URI/{sub(/'[^']+'/,\"'$DRB_URI'\")} {print}" rw-cgi.rb > ${CGIDIR}/$CGINAME
chmod +x ${CGIDIR}/$CGINAME || exit 20
echo -n ${CGINAME}򤷤Ƥ [Press Enter]
read
$EDITOR ${CGIDIR}/${CGINAME} || exit 21
echo RWikiΥ󥹥ȡ뤬λޤ

# RWiki install end


# check original $RUBYLIB
RUBYLIB=$RUBYLIB_ORG
if ruby -e 'exit($:.include?(ARGV[0])||$:.include?(File.expand_path(ARGV[0]))?1:0)' $LIB
then
  echo ʲΤɤ餫Υޥɤ¹Ԥƥ饤֥긡ѥɲäƤ
  if [ -z "$RUBYLIB" ]; then
    echo setenv RUBYLIB $LIB
    echo export RUBYLIB="$LIB"
  else
    echo setenv RUBYLIB ${LIB}:\$RUBYLIB
    echo export RUBYLIB=${LIB}:\$RUBYLIB
  fi
fi

echo ʲΤ褦rwikiФưƤ
echo \$ cd $RWIKI_DIR\; ruby -Ke -I./lib rwiki.rb
echo $CGINAME֥饦ǳƤ
echo 󥹥ȡˤǤѥեˤϰʲΥޥɤ¹ԤƤ
echo \$ rm -rf ${WORK}/rwiki-installer
echo \$ rm ${RWIKIPARENTDIR}/raa-rwiki.html ${RWIKIPARENTDIR}/rwiki-*.tar.gz
